<?php

include ("inc.php3");

include_ecrire("inc_admin.php3");
include_ecrire("inc_meta.php3");


// Les 3 premires fonctions sont empruntes  SPIP 1.8.3

// calcule les referers en plusieurs etapes par tranche de 100
function cron_statistiques($t) {
	global $nombre;
	$pas = 100;

	if (intval($nombre)>0 AND intval($nombre)<1001) $pas=intval($nombre);

	$ref = calculer_n_referers($pas);
	if ($ref == 100) return (0 - $t);
	// Supprimer les referers trop vieux
	supprimer_referers();
	supprimer_referers("article");
	return 1;
}

function cron_popularites($t) {
	// Si c'est le premier appel (fichier .lock absent), ne pas calculer
	if ($t == 0) return 0;
	calculer_popularites($t);
	return 1;
}

function cron_visites($t) {
	// Si le fichier .lock est absent, ne pas calculer (mais reparer la date
	// du .lock de maniere a commencer a 00:00:01 demain).
	if ($t) calculer_visites();

	// il vaut mieux le lancer peu apres minuit, 
	// donc on pretend avoir ete execute precisement "ce matin a 00:00:01"
	// pour etre appele demain a la meme heure
	return 0 - (strtotime(date("d F Y", time()))+60);
}

// Il ne faut pas lancer de tche de fond !
function ci_fin_page($credits='') {
	global $spip_display;

    global $citimedebut;
    
    if ($citimedebut){
	$cimtimef = explode(" ",microtime());
	$citimefin = $cimtimef[1] + $cimtimef[0];
	$cidelai = $citimefin - $citimedebut;
    }	

	echo "</td></tr></table>";

	debut_grand_cadre();
/*
	# ici on en profite pour glisser une tache de fond
	echo "<div align='right' class='verdana2' ";
	echo "style='background: url(\"../spip_background.php3\");' ";
	echo ">";
*/
	if ($spip_display == 4) {
		echo "<div><a href=\"index.php3?set_disp=2\">"._T("access_interface_graphique")."</a></div>";
	} else {
		echo info_copyright();
		echo "<br>"._T('info_copyright_doc');
		if ($citimedebut) echo "<br>Temps de traitement : ".round($cidelai, 3)." secondes";
		echo "</div><p>";
	}

	fin_grand_cadre();
	echo "</center>";

	fin_html();
}

// purge du fichier TEMPORAIRE les statistiques comprises antrieures au 15 mars 2008
// car elles comprennent les nombreuses visites du robot d'indexation de moteur de recherche national Mnogosearch
function ci_purge_spip_visites_temp() {
	$fin = mktime(0, 0, 0, 03, 15, 2008);
	
	$query_effacer = "DELETE FROM spip_visites_temp WHERE UNIX_TIMESTAMP(maj) <".$fin." LIMIT 20000";
	$result_effacer = spip_query($query_effacer);	
}

function ci_purge_spip_referers_temp() {
	$fin = mktime(0, 0, 0, 03, 15, 2008);
	
	$query_effacer2 = "DELETE FROM spip_referers_temp WHERE UNIX_TIMESTAMP(maj) <".$fin." LIMIT 20000";
	$result_effacer2 = spip_query($query_effacer2);		
}



// scurit 
if ($connect_statut != '0minirezo' OR !$connect_toutes_rubriques) {
	echo _T('avis_non_acces_page');
	fin_page();
	exit;
}

if (ereg("[a-z]",$_GET['action'])) {
	$action=$_GET['action'];
} else {
	$action='';
}

$nombre=intval($_GET['nombre']);

$taches=array();




// Partie traitement

// Stat. Attention: la popularite DOIT preceder les visites
if (lire_meta("activer_statistiques") == "oui") {
	if ($action == 'calculreferers') {
		$taches[]= 'statistiques';
	} elseif ($action == 'calculvisites') {
//		$taches[]= 'popularites';
		$taches[]= 'visites';
	} elseif ($action == 'purgervisitestemp') {
		ci_purge_spip_visites_temp();
	} elseif ($action == 'purgerrefererstemp') {
		ci_purge_spip_referers_temp();
	}	
}

// Definit le temps minimal, en secondes, entre deux memes taches 
// NE PAS METTRE UNE VALEUR INFERIEURE A 30 (cf ci-dessus)
// cela entrainerait plusieurs execution en parallele de la meme tache

global $frequence_taches;
$frequence_taches = array(
			  'visites' => 35,
			  'statistiques' => 35,
			  'popularites' => 35
);

// le traitement du foreach est emprunt  SPIP 1.8.3
foreach ($taches as $tache) {
	$lock = _DIR_SESSIONS . $tache . '.lock';
	clearstatcache();
	$last = @filemtime($lock);

	// On opere un double lock : un dans _DIR_SESSIONS, pour les hits
	// (en parallele sur le meme site) ; et un autre dans la base de
	// donnees, de maniere a eviter toute concurrence entre deux SPIP
	// differents partageant la meme base (replication de serveurs Web)
	if (spip_touch($lock, $frequence_taches[$tache])
	AND spip_get_lock('cron'.$tache)) {
		spip_timer('tache');
		include_ecrire('inc_' . $tache . _EXTENSION_PHP);
		$fonction = 'cron_' . $tache;
		$code_de_retour = $fonction($last);
		if ($code_de_retour) {
			$msg = "cron: $tache";
			if ($code_de_retour < 0) {
				# modifier la date du fichier
				@touch($lock, (0 - $code_de_retour));
				spip_log($msg . " (en cours, " . spip_timer('tache') .")");
			}
			else
				spip_log($msg . " (" . spip_timer('tache') . ")");
			break;
		}
		spip_release_lock('cron'.$tache);
	}
}





// Partie affichage des informations

$nbreferers=0;
$nbvisites=0;
$nbvisitesmnogo=0;


$query = "SELECT COUNT(*) as count FROM spip_referers_temp";
$res = spip_query($query);
while ($row = @spip_fetch_array($res)) {
	$nbreferers=$row['count'];
}


$query2 = "SELECT COUNT(*) as count FROM spip_visites_temp";
$res2 = spip_query($query2);
while ($row = @spip_fetch_array($res2)) {
	$nbvisites=$row['count'];
}


$query3 = "SELECT COUNT(*) as count FROM spip_visites_temp WHERE UNIX_TIMESTAMP(maj) < ".mktime(0, 0, 0, 03, 15, 2008);
$res3 = spip_query($query3);
while ($row = @spip_fetch_array($res3)) {
	$nbvisitesmnogo=$row['count'];
}

$query4 = "SELECT COUNT(*) as count FROM spip_referers_temp WHERE UNIX_TIMESTAMP(maj) < ".mktime(0, 0, 0, 03, 15, 2008);
$res4 = spip_query($query4);
while ($row = @spip_fetch_array($res4)) {
	$nbreferersmnogo=$row['count'];
}


debut_page(_L('Calcul des statistiques'), "administration", "cache");
echo '<br /><br /><br /><br />';
gros_titre(_L('Calcul des statistiques'));
debut_gauche();
debut_droite();

echo "<b>".$nbreferers.'</b> referers figurent dans le fichier temporaire et restent  calculer<br />';
if (lire_meta("activer_statistiques") == "oui") {
	echo "<a href='_giseh_admin_stat.php3?action=calculreferers&nombre=100'>"._L('Cliquez ici pour calculer les referers (et attendre 35 secondes)').'</a><br />';
}
echo '<br />';

echo "<b>".$nbvisites.'</b> visites figurent dans le fichier temporaire et restent  calculer<br />';
if (lire_meta("activer_statistiques") == "oui") {
	echo "<a href='_giseh_admin_stat.php3?action=calculvisites'>"._L('Cliquez ici pour calculer les visites (et attendre 35 secondes)').'</a><br />';
}
echo '<br /><br /><br /><br />';

echo "<b>".$nbreferersmnogo.'</b> referers concernent la priode antrieure au 15/03/08 dans le fichier TEMPORAIRE (ils comprennent les nombreuses visites du robot d\'indexation de moteur de recherche national Mnogosearch)<br />';
if ($nbreferersmnogo>0) {
	if (lire_meta("activer_statistiques") == "oui") {
		echo '<b>ATTENTION, le traitement propos ci-dessous est irrversible :</b><br />';
		echo "<a href='_giseh_admin_stat.php3?action=purgerrefererstemp'>"._L('Cliquez ici pour purger du fichier TEMPORAIRE les referers antrieurs au 15 mars 2008 (par tranche de 20000 au plus)').'</a><br />';
	}
}
echo '<br />';
echo "<b>".$nbvisitesmnogo.'</b> visites concernent la priode antrieure au 15/03/08 dans le fichier TEMPORAIRE (elles comprennent les nombreuses visites du robot d\'indexation de moteur de recherche national Mnogosearch)<br />';
if ($nbvisitesmnogo>0) {
	if (lire_meta("activer_statistiques") == "oui") {
		echo '<b>ATTENTION, le traitement propos ci-dessous est irrversible :</b><br />';
		echo "<a href='_giseh_admin_stat.php3?action=purgervisitestemp'>"._L('Cliquez ici pour purger du fichier TEMPORAIRE les visites antrieures au 15 mars 2008 (par tranche de 20000 au plus)').'</a><br />';
	}
}
echo '<br /><br /><br /><br />';

ci_fin_page();


?>