<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2008                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/

if (!defined("_ECRIRE_INC_VERSION")) return;


include_ecrire("inc_meta.php3");
include_ecrire("inc_index.php3");
include_ecrire("inc_texte.php3");
include_ecrire("inc_filtres.php3");
include_ecrire("inc_lang.php3");
include_ecrire("inc_documents.php3");

function giseh_action_editer_document($array_droits,$connect_id_auteur,$connect_statut,$cilogin) {

	$return = true;
	
	//-------------------------------------------------------
	// securite
	$ci_id_article = _cireqsecure('id_article');
	$ci_id_rubrique = _cireqsecure('id_rubrique');
	$ci_id_document = _cireqsecure('id_document');
	$cititre = _cireqsecure('titre');
	$ci_ciposition = _cireqsecure('ciposition');
	$ci_ins_document = _cireqsecure('ins_document');
	$ci_ins_image = _cireqsecure('ins_image');
	$ci_align_image = _cireqsecure('align_image');

	$largeur_document = _cireqsecure('largeur_document');
	$hauteur_document = _cireqsecure('hauteur_document');
	
	
	// indispensable pour le template 
	$_GET['id_article']=$ci_id_article;
	$_GET['id_rubrique']=$ci_id_rubrique;
	
	
	
	//-------------------------------------------------------
	// Enregistrer les modifications
	
	if ($ci_id_document>0) {
		if ($largeur_document>0 AND $hauteur_document>0) {		
			cisql_updateq("spip_documents", array("titre" => $cititre, "descriptif" => _cireqsecure('descriptif'), "largeur" => $largeur_document, "hauteur" => $hauteur_document), "id_document=$ci_id_document");
		} else {
			cisql_updateq("spip_documents", array("titre" => $cititre, "descriptif" => _cireqsecure('descriptif')), "id_document=$ci_id_document");
		}
	}	
	
	//-------------------------------------------------------
	// Insertion d'un document dans le texte
	if ($ci_id_article>0 AND $ci_id_document>0) {
		if (isset($_POST['bt_vignette'])) {
			// ne rien faire dans ce cas
		} else {
			if ($ci_ins_document OR $ci_ins_image) {
				if ($ci_ins_document=="descriptif" OR $ci_ins_document=="texte") {
					if ($row = cisql_fetsel("id_article, descriptif, texte", "spip_articles", "id_article=$ci_id_article")) {
						$olddescriptif = $row['descriptif'];
						$oldtexte = $row['texte'];
						$array_align = array("left","center","right");
						if ($ci_ins_document=="descriptif") {
							if (in_array($ci_align_image,$array_align)) {
								$olddescriptif=str_replace("~~","<emb".$ci_id_document."|".$ci_align_image.">",$olddescriptif);
							} else {
								$olddescriptif=str_replace("~~","<doc".$ci_id_document.">",$olddescriptif);
							}
							cisql_updateq("spip_articles", array("descriptif" => $olddescriptif), "id_article=$ci_id_article");
						} elseif ($ci_ins_document=="texte") {
							if (in_array($ci_align_image,$array_align)) {
								$oldtexte=str_replace("~~","<emb".$ci_id_document."|".$ci_align_image.">",$oldtexte);
							} else {
								$oldtexte=str_replace("~~","<doc".$ci_id_document.">",$oldtexte);
							}
							cisql_updateq("spip_articles", array("texte" => $oldtexte), "id_article=$ci_id_article");
						}
					}
				}				
				if ($ci_ins_image=="descriptif" OR $ci_ins_image=="texte") {
					if (!$ci_align_image) $ci_align_image = "left";
					if ($row = cisql_fetsel("id_article, descriptif, texte", "spip_articles", "id_article=$ci_id_article")) {
						$olddescriptif = $row['descriptif'];
						$oldtexte = $row['texte'];
						if ($ci_ins_image=="descriptif") {
							$olddescriptif=str_replace("~~","<img".$ci_id_document."|".$ci_align_image.">",$olddescriptif);
							cisql_updateq("spip_articles", array("descriptif" => $olddescriptif), "id_article=$ci_id_article");
						} elseif ($ci_ins_image=="texte") {
							$oldtexte=str_replace("~~","<img".$ci_id_document."|".$ci_align_image.">",$oldtexte);
							cisql_updateq("spip_articles", array("texte" => $oldtexte), "id_article=$ci_id_article");
						}
													
					}
					
				}				
			}
		}
	}

	return $return;
	
}
	
?>