<?php

if (!defined("_ECRIRE_INC_VERSION")) return;


// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_GISEH_INC_ABSTRACT_SQL")) return;
define("_ECRIRE_GISEH_INC_ABSTRACT_SQL", "1");


//--------- Debut ajout CI ---------------------

//-------------------------------------------------------
// Couche d'abstraction SQL (inspire de SPIP 1.9)

function cidescription_table($nom){
        global $tables_principales, $tables_auxiliaires;

        include_ecrire('inc_serialbase.php3');
        if (isset($tables_principales[$nom]))
                return $tables_principales[$nom];

        include_ecrire('inc_auxbase.php3');
        if (isset($tables_auxiliaires[$nom]))
                return $tables_auxiliaires[$nom];
}

function cicalculer_mysql_where($v)
{
	if (!is_array($v))
	  return $v ;

	$op = array_shift($v);
	if (!($n=count($v)))
		return $op;
	else {
		$arg = cicalculer_mysql_where(array_shift($v));
		if ($n==1) {
			  return "$op($arg)";
		} else {
			$arg2 = cicalculer_mysql_where(array_shift($v));
			if ($n==2) {
				return "($arg $op $arg2)";
			} else return "($arg $op ($arg2) : $v[0])";
		}
	}
}

function cicalculer_mysql_expression($expression, $v, $join = 'AND'){
	if (empty($v))
		return '';
	
	$exp = "\n$expression ";
	
	if (!is_array($v)) {
		return $exp . $v;
	} else {
		if (strtoupper($join) === 'AND')
			return $exp . join("\n\t$join ", array_map('cicalculer_mysql_where', $v));
		else
			return $exp . join($join, $v);
	}
}

function ci_mysql_order($orderby)
{
	return (is_array($orderby)) ? join(", ", $orderby) :  $orderby;
}

function ci_mysql_select_as($args)
{
	if (isset($args[-1])) {
		$join = ' ' . $args[-1];
		unset($args[-1]);
	} else $join ='';
	$res = '';
	foreach($args as $k => $v) {
		$res .= ', ' . $v . (is_numeric($k) ? '' : " AS `$k`") . $join;
		$join = '';
	}
	return substr($res,2);
}

function ci_ctype_xdigit($string = ""){
    return !strlen(trim($string,"1234567890abcdefABCDEF"));
}
    
function ci_mysql_cite($v, $type) {
	if (cisql_test_date($type) AND preg_match('/^\w+\(/', $v)
	OR (cisql_test_int($type)
		 AND (is_numeric($v)
		      OR (ci_ctype_xdigit(substr($v,2))
			  AND $v[0]=='0' AND $v[1]=='x'))))
		return $v;
	else return  ("'" . addslashes($v) . "'");
}

function cisql_test_date($type, $serveur='')
{
  return (preg_match('/^datetime/i',$type)
	  OR preg_match('/^timestamp/i',$type));
}

function cisql_test_int($type, $serveur='')
{
  return (preg_match('/^bigint/i',$type)
	  OR preg_match('/^int/i',$type)
	  OR preg_match('/^tinyint/i',$type));
}

function cisql_select (
	$select = array(), $from = array(), $where = array(),
	$groupby = array(), $orderby = array(), $limit = '', $having = array(),
	$serveur='') {

	$from = (!is_array($from) ? $from : ci_mysql_select_as($from));
	$query = 
		  cicalculer_mysql_expression('SELECT', $select, ', ')
		. cicalculer_mysql_expression('FROM', $from, ', ')
		. cicalculer_mysql_expression('WHERE', $where)
		. cicalculer_mysql_expression('GROUP BY', $groupby, ',')
		. cicalculer_mysql_expression('HAVING', $having)
		. ($orderby ? ("\nORDER BY " . ci_mysql_order($orderby)) :'')
		. ($limit ? "\nLIMIT $limit" : '');
	return spip_query($query);
}

function cisql_updateq($table, $champs, $where='', $desc=array(), $serveur='') {
	if (!$champs) return;
	if (!$desc) $desc = cidescription_table($table);
	if (!$desc) die("$table insertion sans description");
	$fields =  $desc['field'];
	$set = array();
	foreach ($champs as $champ => $val) {
		$set[] = $champ . '=' . ci_mysql_cite($val, $fields[$champ]);
	}
	return spip_query(
			  cicalculer_mysql_expression('UPDATE', $table, ',')
			. cicalculer_mysql_expression('SET', $set, ',')
			. cicalculer_mysql_expression('WHERE', $where)
			);

}

function ci_mysql_insert($table, $champs, $valeurs, $desc='', $serveur='') 
{
	$query="INSERT INTO $table $champs VALUES $valeurs";
	spip_query($query);
	return  mysql_insert_id();
}

function cisql_insertq($table, $couples=array(), $desc=array(), $serveur='')
{
	if (!$desc) $desc = cidescription_table($table);
	if (!$desc) die("$table insertion sans description");
	$fields =  isset($desc['field'])?$desc['field']:array();

	foreach ($couples as $champ => $val) {
		$couples[$champ]= ci_mysql_cite($val, $fields[$champ]);
	}

	return ci_mysql_insert($table, "(".join(',',array_keys($couples)).")", "(".join(',', $couples).")", $desc, $serveur);
}

function cisql_delete($table, $where='', $serveur='')
{
		return spip_query(
			  cicalculer_mysql_expression('DELETE FROM', $table, ',')
			. cicalculer_mysql_expression('WHERE', $where)
			);
}

function cisql_fetsel(
	$select = array(), $from = array(), $where = array(),
	$groupby = array(), $orderby = array(), $limit = '',
	$having = array(), $serveur='') {
	return spip_fetch_array(cisql_select($select, $from, $where, $groupby, $orderby, $limit, $having, $serveur));
}

function cisql_fetch($res) {
	return spip_fetch_array($res);
}


function cisql_count($res, $serveur='')
{
	if ($res) {
		return mysql_num_rows($res);
	} else {
		return 0;
	}
}


//---------- Fin ajout CI --------------------

?>