<?php

/***************************************************************************\
 *  SPIP, Systeme de publication pour l'internet                           *
 *                                                                         *
 *  Copyright (c) 2001-2005                                                *
 *  Arnaud Martin, Antoine Pitrou, Philippe Riviere, Emmanuel Saint-James  *
 *                                                                         *
 *  Ce programme est un logiciel libre distribue sous licence GNU/GPL.     *
 *  Pour plus de details voir le fichier COPYING.txt ou l'aide en ligne.   *
\***************************************************************************/


//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_ACCES")) return;
define("_ECRIRE_INC_ACCES", "1");


function creer_pass_aleatoire($longueur = 8, $sel = "") {
	$seed = (double) (microtime() + 1) * time();
	mt_srand($seed);
	srand($seed);
	$s = '';
	$pass = '';
	for ($i = 0; $i < $longueur; $i++) {
		if (!$s) {
			$s = mt_rand();
			if (!$s) $s = rand();
			$s = substr(md5(uniqid($s).$sel), 0, 16);
		}
		$r = unpack("Cr", pack("H2", $s.$s));
		$x = $r['r'] & 63;
		if ($x < 10) $x = chr($x + 48);
		else if ($x < 36) $x = chr($x + 55);
		else if ($x < 62) $x = chr($x + 61);
		else if ($x == 63) $x = '/';
		else $x = '.';
		$pass .= $x;
		$s = substr($s, 2);
	}
	$pass = ereg_replace("[./]", "a", $pass);
	$pass = ereg_replace("[I1l]", "L", $pass);
	$pass = ereg_replace("[0O]", "o", $pass);
	return $pass;
}


//
// low-security : un ensemble de fonctions pour gerer de l'identification
// faible via les URLs (suivi RSS, iCal...)
//
function low_sec($id_auteur) {
	// Pas d'id_auteur : low_sec
	if (!$id_auteur = intval($id_auteur)) {
		if (!$low_sec = lire_meta('low_sec')) {
			include_ecrire('inc_meta.php3');
			ecrire_meta('low_sec', $low_sec = creer_pass_aleatoire());
			ecrire_metas();
		}
	}
	else {
		$query = "SELECT * FROM spip_auteurs WHERE id_auteur = $id_auteur";
		$result = spip_query($query);

		if ($row = spip_fetch_array($result)) {
			$low_sec = $row["low_sec"];
			if (!$low_sec) {
				$low_sec = creer_pass_aleatoire();
				spip_query("UPDATE spip_auteurs SET low_sec = '$low_sec' WHERE id_auteur = $id_auteur");
			}
		}
	}
	return $low_sec;
}

function afficher_low_sec ($id_auteur, $action='') {
	return substr(md5($action.low_sec($id_auteur)),0,8);
}

function verifier_low_sec ($id_auteur, $cle, $action='') {
	return ($cle == afficher_low_sec($id_auteur, $action));
}

function effacer_low_sec($id_auteur) {
	if (!$id_auteur = intval($id_auteur)) return; // jamais trop prudent ;)
	spip_query("UPDATE spip_auteurs SET low_sec = '' WHERE id_auteur = $id_auteur");
}


// Une fonction service qui affiche le statut de l'auteur dans l'espace prive
//--------- Debut ajout CI (ec) --------------
// function afficher_formulaire_statut_auteur ($id_auteur, $statut, $post='') {
function afficher_formulaire_statut_auteur ($id_auteur, $auteur, $post='') {
	global $ci_ajout_interdit, $ci_suppr_interdit,$ci_titre_rub;
//--------- Fin ajout CI ---------------------
	global $connect_statut, $connect_toutes_rubriques, $connect_id_auteur;
	global $spip_lang_right;

//--------- Debut ajout CI (ec) --------------
$statut=$auteur['statut'];
//--------- Fin ajout CI ---------------------

	if ($post) {
		$url_self = $post;
		echo "<p />";
		echo "<form action='$post' method='post'>\n";
	} else
		$url_self = "auteur_infos.php3?id_auteur=$id_auteur";


	// S'agit-il d'un admin restreint ?
//--------- Debut ajout CI (cloisonnement_ep) ---------
/*
	if ($statut == '0minirezo') {
		$query_admin = "SELECT lien.id_rubrique, titre FROM spip_auteurs_rubriques AS lien, spip_rubriques AS rubriques WHERE lien.id_auteur=$id_auteur AND lien.id_rubrique=rubriques.id_rubrique GROUP BY lien.id_rubrique";
		$result_admin = spip_query($query_admin);
		$admin_restreint = (spip_num_rows($result_admin) > 0);
	}
*/	
	$query_admin = "SELECT lien.id_rubrique, titre FROM spip_auteurs_rubriques AS lien, spip_rubriques AS rubriques WHERE lien.id_auteur=$id_auteur AND lien.id_rubrique=rubriques.id_rubrique GROUP BY lien.id_rubrique";
	$result_admin = spip_query($query_admin);
	$admin_restreint = (spip_num_rows($result_admin) > 0);
//--------- Fin ajout CI -----------------------------

	// Seuls les admins voient le menu 'statut' ; les admins restreints
	// ne peuvent l'utiliser que pour mettre un auteur a la poubelle
//--------- Debut ajout CI (cloisonnement_ep) ---------
/*	if ($connect_statut == "0minirezo"
	AND ($connect_toutes_rubriques OR $statut != "0minirezo")
	AND $connect_id_auteur != $id_auteur) {
*/	
	if ($connect_statut == "0minirezo"
	AND ($connect_toutes_rubriques)
	AND $connect_id_auteur != $id_auteur) {
//--------- Fin ajout CI -----------------------------
		debut_cadre_relief();

//--------- Debut ajout CI (cloisonnement_ep) ---------
/*
		if ($statut == '0minirezo') {
			if ($admin_restreint)
				echo bouton_block_visible("statut$id_auteur");
			else
				echo bouton_block_invisible("statut$id_auteur");
		}
*/
		echo bouton_block_visible("statut$id_auteur");		
//--------- Fin ajout CI -----------------------------

		echo "<b>"._T('info_statut_auteur')." </b> ";
		echo "<select name='statut' size=1 class='fondl'>";

		if ($connect_statut == "0minirezo" AND $connect_toutes_rubriques)
			echo "<OPTION".mySel("0minirezo",$statut).">"._T('item_administrateur_2');

		echo "<OPTION".mySel("1comite",$statut).">"._T('intem_redacteur');
//--------- Debut ajout CI (statut ciredval) ---------
		echo "<OPTION".mySel("ciredval",$statut).">"._T('item_ciredval');
//--------- Fin ajout CI -----------------------------

//--------- Debut ajout CI (permettre de crer un visiteur) ---------------------
/*		if (($statut == '6forum')
		OR (lire_meta('accepter_visiteurs') == 'oui')
		OR (lire_meta('forums_publics') == 'abo')
		OR spip_num_rows(spip_query("SELECT statut
		FROM spip_auteurs WHERE statut='6forum'")))
*/		
//--------- Fin ajout CI ---------------------
			echo "<OPTION".mySel("6forum",$statut).">"._T('item_visiteur');
		echo "<OPTION".mySel("5poubelle",$statut).
		  " style='background:url(" . _DIR_IMG_PACK . "rayures-sup.gif)'>&gt; "._T('texte_statut_poubelle');

		echo "</select>\n";

		//
		// Gestion restreinte des rubriques
		//
//--------- Debut ajout CI (cloisonnement_ep) (ec) (ciredval) --------------
/*
		if ($statut == '0minirezo') {
			if (!$admin_restreint) {
				echo debut_block_invisible("statut$id_auteur");
				echo "<p /><div style='arial2'>\n";
				echo _T('info_admin_gere_toutes_rubriques');
			} else {
				echo debut_block_visible("statut$id_auteur");
				echo "<p /><div style='arial2'>\n";
				echo _T('info_admin_gere_rubriques')."\n";
*/
		if (($statut == '0minirezo') OR ($statut == '1comite') OR ($statut == 'ciredval')) {
			// (ec) ajout de ci_droit_id_auteur
			if (!$admin_restreint  OR ci_droit_id_auteur($id_auteur, 'ecadminsite')) {
				echo debut_block_visible("statut$id_auteur");
				echo "<p /><div style='arial2'>\n";
				if ($statut == '1comite') {
					echo _T('info_equip_redacteur_lire_toutes_rubriques');
				} else {	
					echo _T('info_admin_gere_toutes_rubriques');
				}	
			} else {
				echo debut_block_visible("statut$id_auteur");
				echo "<p /><div style='arial2'>\n";
				if ($statut == '1comite') {
					echo _T('info_equip_redacteur_lire_rubriques');
				} else {	
					echo _T('info_admin_gere_rubriques')."\n";
				}	
//----------------- Fin ajout CI ---------------------------
				echo "<ul style='list-style-image: url(" . _DIR_IMG_PACK . "rubrique-12.gif)'>";
				while ($row_admin = spip_fetch_array($result_admin)) {
					$id_rubrique = $row_admin["id_rubrique"];
					$titre = typo($row_admin["titre"]);
					echo "<li>$titre";
					if ($connect_toutes_rubriques
					AND $connect_id_auteur != $id_auteur) {
						echo " <font size=1>"
						. "[<a href='$url_self&supp_rub=$id_rubrique'>"
						._T('lien_supprimer_rubrique')
						."</a>]</font>";
					}
					$toutes_rubriques .= "$id_rubrique,";
				}
				echo "</ul>";
				$toutes_rubriques = ",$toutes_rubriques";
			}
	
			if ($connect_toutes_rubriques
			AND $connect_id_auteur != $id_auteur) {
				echo "</div><br /><div class='arial1'>";
//--------- Debut ajout CI (cloisonnement_ep) --------------
	  	     if (!ci_droit_id_auteur($id_auteur, 'ecadminsite')) {			
//----------------- Fin ajout CI ---------------------------
				
				if (spip_num_rows($result_admin) == 0) {
//--------- Debut ajout CI (cloisonnement_ep) --------------
//					echo "<b>"._T('info_restreindre_rubrique')."</b><br />";
//				} else {
//					echo "<b>"._T('info_ajouter_rubrique')."</b><br />";
					if ($statut == '1comite') {
						echo "<b>"._T('info_equip_redacteur_restreindre_rubrique')."</b><br />";
					} else {	
						echo "<b>"._T('info_restreindre_rubrique')."</b><br />";
					}	
				} else {
					if ($statut == '1comite') {
						echo "<b>"._T('info_equip_redacteur_ajouter_rubrique')."</b><br />";
					} else {	
						echo "<b>"._T('info_ajouter_rubrique')."</b><br />";
					}	
//----------------- Fin ajout CI ---------------------------
				}
//--------- Debut ajout CI (ec) ---------------------
				if ($ci_ajout_interdit or $ci_suppr_interdit){
					$ci_message = "La rubrique '".$ci_titre_rub."' n'a pas t ";
					if ($ci_ajout_interdit) {
						$ci_message .="ajoute";	
					} else {
						$ci_message .="supprime";	
					}
					$ci_message .=" car une de ses rubriques parentes, ou bien elle mme, est un espace collaboratif.<BR>";
					echo $ci_message;		
				}
//--------- Fin ajout CI ---------------------		
				echo "<INPUT NAME='id_auteur' VALUE='$id_auteur' TYPE='hidden'>";
				echo "<SELECT NAME='add_rub' SIZE=1 CLASS='formo'>";
				echo "<OPTION VALUE='0'>\n";
				afficher_auteur_rubriques("0");
				echo "</SELECT>";
//--------- Debut ajout CI (ec) ---------------------
  	     	 } 	
//--------- Fin ajout CI ---------------------
			}

			echo "</div>\n";
			echo fin_block();
		}

//--------- Debut ajout CI (ec) ---------------------
	} elseif ($connect_statut == "0minirezo"
	AND ($connect_toutes_rubriques)
	AND $connect_id_auteur == $id_auteur) {

		debut_cadre_relief();
		echo bouton_block_visible("statut$id_auteur");		
		echo "<b>"._T('info_statut_auteur')." </b> ";
		echo _T('item_administrateur_2');
		echo "<INPUT NAME='statut' VALUE='0minirezo' TYPE='hidden'>";
		echo "<INPUT NAME='id_auteur' VALUE='$id_auteur' TYPE='hidden'>";
		echo fin_block();		
	}
	
	if ($connect_statut == "0minirezo"
	AND ($connect_toutes_rubriques)) {

// if (($statut == '0minirezo') AND (!$connect_toutes_rubriques OR $connect_id_auteur != $id_auteur) AND !$citoutesrub) {
if (($statut == '0minirezo') AND $admin_restreint AND !ci_droit_id_auteur($id_auteur, 'ecadminsite')) {	
	if ($connect_statut == "0minirezo" AND $connect_toutes_rubriques){
		debut_cadre_relief("cadenas-24.gif");
//		echo "<B>"._T('entree_gerer_ec')."</B><BR>";
		
		echo "<TABLE  width='100%'>";
		echo "<TR>";
		echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='75%'>";
		echo _T('entree_gerer_ec');
		echo "</TD>";
		echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='25%'>";
		if ($auteur['pgpeccma'] == 'eccma'){
			echo "<input type='radio' name='pgpeccma' value='eccma' id='label_eccma2' checked> <label for='label_eccma2'><b>Oui</b></label>&nbsp;";
			echo "<input type='radio' name='pgpeccma' value='non' id='label_eccma3'> <label for='label_eccma3'>Non</label>";
		} else {
			echo "<input type='radio' name='pgpeccma' value='eccma' id='label_eccma2'> <label for='label_eccma2'>Oui</label>&nbsp;";
			echo "<input type='radio' name='pgpeccma' value='non' id='label_eccma3' checked> <label for='label_eccma3'><b>Non</b></label>";
		}		
		echo "</TD></TR>\n";
		echo "</TABLE>";
		
		fin_cadre_relief();
		echo "<input type='hidden' name='pgpecadminsite' value='non'>";
		echo "<input type='hidden' name='pgpecredacnr' value='non'>";
		echo "<p>";
	} elseif ($connect_id_auteur == $id_auteur) {
		if ($auteur['pgpeccma'] == 'eccma') {
			echo "Cet administrateur restreint est autoris&eacute; &agrave; cr&eacute;er des espaces collaboratifs.";
		}	
	}
	
} elseif (($statut == '0minirezo') AND ($connect_toutes_rubriques OR ci_droit_id_auteur($id_auteur, 'ecadminsite'))) {
	if ($connect_statut == "0minirezo" AND $connect_toutes_rubriques){
		debut_cadre_relief("cadenas-24.gif");
		echo "<TABLE  width='100%'>";
		if ($auteur['pgpecadminsite'] == 'ecadminsite' OR $auteur['pgpecadminsite'] == 'ecadminrestreint'){
		} else {
			echo "<TR>";
			echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='90%'><label for='label_ecadminsite1'>";
			echo _T('entree_ec_admin');
			echo "</label></TD>";
			echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='10%'>";
				echo "<input type='radio' name='pgpecadminsite' value='non' id='label_ecadminsite1' checked>";
			echo "</TD></TR>\n";
		}		
		echo "<TR>";
		echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='90%'><label for='label_ecadminsite2'>";
		echo _T('entree_ec_adminsite');
		echo "</label></TD>";
		echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='10%'>";
		if ($auteur['pgpecadminsite'] == 'ecadminsite'){
			echo "<input type='radio' name='pgpecadminsite' value='ecadminsite' id='label_ecadminsite2' checked>";
		} else {
			echo "<input type='radio' name='pgpecadminsite' value='ecadminsite' id='label_ecadminsite2'>";
		}		
		echo "</TD></TR>\n";
		if ($connect_id_auteur != $id_auteur) {
			echo "<TR>";
			echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='90%'><label for='label_ecadminsite3'>";
			echo _T('entree_ec_adminrestreint');
			echo "</label></TD>";
			echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='10%'>";
			if ($auteur['pgpecadminsite'] == 'ecadminrestreint'){
				echo "<input type='radio' name='pgpecadminsite' value='ecadminrestreint' id='label_ecadminsite3' checked>";
			} else {
				echo "<input type='radio' name='pgpecadminsite' value='ecadminrestreint' id='label_ecadminsite3'>";
			}		
			echo "</TD></TR>\n";
		}	
		echo "</TABLE>";

		fin_cadre_relief();
		echo "<input type='hidden' name='pgpeccma' value='non'>";
		echo "<input type='hidden' name='pgpecredacnr' value='non'>";
		echo "<p>";
	} elseif ($connect_id_auteur == $id_auteur) {
		if ($auteur['pgpecadminsite'] == 'ecadminsite') {
			echo _T('entree_ec_adminsite');		
		}	
	}
	
} elseif ((($statut == '1comite') OR ($statut == 'ciredval')) AND ($connect_toutes_rubriques)) {
	if ($connect_statut == "0minirezo" AND $connect_toutes_rubriques){
		debut_cadre_relief("cadenas-24.gif");
		
		echo "<TABLE  width='100%'>";
		echo "<TR>";
		echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='75%'>";
		echo _T('entree_ec_redacnr');
		echo "</TD>";
		echo "<TD ALIGN='$spip_lang_left' class='verdana2' width='25%'>";
		if ($auteur['pgpecredacnr'] == 'ecredacnr'){
			echo "<input type='radio' name='pgpecredacnr' value='ecredacnr' id='label_ecredacnr2' checked> <label for='label_ecredacnr2'><b>Oui</b></label>&nbsp;";
			echo "<input type='radio' name='pgpecredacnr' value='non' id='label_ecredacnr3'> <label for='label_ecredacnr3'>Non</label>";
		} else {
			echo "<input type='radio' name='pgpecredacnr' value='ecredacnr' id='label_ecredacnr2'> <label for='label_ecredacnr2'>Oui</label>&nbsp;";
			echo "<input type='radio' name='pgpecredacnr' value='non' id='label_ecredacnr3' checked> <label for='label_ecredacnr3'><b>Non</b></label>";
		}		
		echo "</TD></TR>\n";
		echo "</TABLE>";
		
		fin_cadre_relief();
		echo "<input type='hidden' name='pgpeccma' value='non'>";
		echo "<input type='hidden' name='pgpecadminsite' value='non'>";		
		echo "<p>";
	} elseif ($connect_id_auteur == $id_auteur) {
		if ($auteur['pgpecredacnr'] == 'ecredacnr') {
			echo _T('entree_ec_redacnr');
		}	
	}
}

//--------- Fin ajout CI ---------------------
		

		if ($post) {
			echo "<div align='$spip_lang_right'><input type='submit'
			class='fondo' name='Valider'
			value=\""._T('bouton_valider')."\" /></div>"; 
			echo "</form>\n";
		}

		fin_cadre_relief();
	}
}

//--------------------- Debut ajout CI (ec) ------------------
// function modifier_statut_auteur (&$auteur, $statut, $add_rub='', $supp_rub='') {
function modifier_statut_auteur (&$auteur, $statut, $add_rub='', $supp_rub='', $pgpeccma, $pgpecadminsite, $pgpecredacnr) {
	global $ci_ajout_interdit, $ci_suppr_interdit, $ci_titre_rub;
//--------- Fin ajout CI ---------------------
	global $connect_statut, $connect_toutes_rubriques;
	// changer le statut ?
	if ($connect_statut == '0minirezo' AND $statut) {
//--------------------- Debut ajout CI (ec) ------------------
		$ciold_statut=$auteur['statut'];
		$cinewpgp = ci_majpgp($auteur['pgp'],'eccma',addslashes($pgpeccma));
		$cinewpgp = ci_majpgp($cinewpgp,'ecadminsite',addslashes($pgpecadminsite));
		$cinewpgp = ci_majpgp($cinewpgp,'ecredacnr',addslashes($pgpecredacnr));
		// protection en cas de changement de statut
		// sauf si on passe de rdacteur  rdacteur qui peut publier ses articles et inversement
		if ($ciold_statut AND ($ciold_statut <> $statut) AND !($ciold_statut=='1comite' AND $statut=='ciredval') AND !($ciold_statut=='ciredval' AND $statut=='1comite')) $cinewpgp="";
		
		spip_query("UPDATE spip_auteurs SET pgp='".$cinewpgp."' 
		WHERE id_auteur=".$auteur['id_auteur']);
//--------- Fin ajout CI ---------------------	
//----------------- Debut ajout CI (statut ciredval) ---------------------------
//		if (ereg("^(0minirezo|1comite|5poubelle|6forum)$",$statut)) {
		if (ereg("^(0minirezo|1comite|ciredval|5poubelle|6forum)$",$statut)) {
//----------------- Fin ajout CI -----------------------------------------------
			$auteur['statut'] = $statut;
			spip_query("UPDATE spip_auteurs SET statut='".$statut."'
			WHERE id_auteur=".$auteur['id_auteur']);
		}
		
	}
	// modif auteur restreint, seulement pour les admins
	
//--------- Debut ajout CI (ec) --------------------------
/*
	if ($connect_toutes_rubriques) {
		if ($add_rub=intval($add_rub))
			spip_query("INSERT INTO spip_auteurs_rubriques
			(id_auteur,id_rubrique)
			VALUES(".$auteur['id_auteur'].", $add_rub)");

		if ($supp_rub=intval($supp_rub))
			spip_query("DELETE FROM spip_auteurs_rubriques
			WHERE id_auteur=".$auteur['id_auteur']."
			AND id_rubrique=$supp_rub");
	}
*/			
		$ci_ajout_interdit=false;
		if (($connect_statut == "0minirezo" AND $connect_toutes_rubriques) AND $add_rub=intval($add_rub)){
			$cirubasc=ci_ascendance($add_rub);
//			$cirubdesc=ci_descendance($add_rub);	
//			$ciliste_rubriques = substr($cirubasc,0,-2).substr($cirubdesc,1);
			$ciliste_rubriques = substr($cirubasc,0,-2).$add_rub.")";

			$query_ari = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_rubrique IN ".$ciliste_rubriques." AND lien_mot.id_mot=mots.id_mot AND mots.titre='_acces_indiv'";
			$result_ari = spip_query($query_ari);
			
			if (spip_num_rows($result_ari)==0){
				spip_query("INSERT INTO spip_auteurs_rubriques
				(id_auteur,id_rubrique)
				VALUES(".$auteur['id_auteur'].", $add_rub)");
			} else {
				$ci_ajout_interdit=true;
				$ci_titre_rub="";
				$query = "SELECT titre FROM spip_rubriques AS rubriques WHERE rubriques.id_rubrique=$add_rub";
				$result = spip_query($query);
				while ($row = spip_fetch_array($result)) {
					$ci_titre_rub = $row["titre"];
				}	
			}	
		}

		$ci_suppr_interdit=false;
		if (($connect_statut == "0minirezo" AND $connect_toutes_rubriques) AND $supp_rub=intval($supp_rub)){
			$cirubasc=ci_ascendance($supp_rub);
		//	$cirubdesc=ci_descendance($supp_rub);	
		//	$ciliste_rubriques = substr($cirubasc,0,-2).substr($cirubdesc,1);
			$ciliste_rubriques = substr($cirubasc,0,-2).$supp_rub.")";
		
			$query_ari = "SELECT lien_mot.id_rubrique FROM spip_mots_rubriques AS lien_mot,spip_mots AS mots WHERE lien_mot.id_rubrique IN ".$ciliste_rubriques." AND lien_mot.id_mot=mots.id_mot AND mots.titre='_acces_indiv'";
			$result_ari = spip_query($query_ari);
			
			if (spip_num_rows($result_ari)==0){
				spip_query("DELETE FROM spip_auteurs_rubriques
				WHERE id_auteur=".$auteur['id_auteur']."
				AND id_rubrique=$supp_rub");
			} else {
				$ci_suppr_interdit=true;
				$ci_titre_rub="";
				$query = "SELECT titre FROM spip_rubriques AS rubriques WHERE rubriques.id_rubrique=$supp_rub";
				$result = spip_query($query);
				while ($row = spip_fetch_array($result)) {
					$ci_titre_rub = $row["titre"];
				}	
			}	
		}
//--------- Fin ajout CI ---------------------
	
}


function initialiser_sel() {
	global $htsalt;

	$htsalt = '$1$'.creer_pass_aleatoire();
}


function ecrire_logins($fichier, $tableau_logins) {
	reset($tableau_logins);

	while(list($login, $htpass) = each($tableau_logins)) {
		if ($login && $htpass) {
			fputs($fichier, "$login:$htpass\n");
		}
	}
}


function ecrire_acces() {
	$htaccess = _DIR_RESTREINT . _ACCESS_FILE_NAME;
	$htpasswd = _DIR_SESSIONS . _AUTH_USER_FILE;

	// si .htaccess existe, outrepasser spip_meta
	if ((lire_meta('creer_htpasswd') == 'non') AND !@file_exists($htaccess)) {
		@unlink($htpasswd);
		@unlink($htpasswd."-admin");
		return;
	}

	# remarque : ici on laisse passer les "nouveau" de maniere a leur permettre
	# de devenir "1comite" le cas echeant (auth http)... a nettoyer
	$query = "SELECT login, htpass FROM spip_auteurs WHERE statut != '5poubelle' AND statut!='6forum'";
	$result = spip_query_db($query);	// attention, il faut au prealable se connecter a la base (necessaire car utilise par install.php3)
	$logins = array();
	while($row = spip_fetch_array($result)) $logins[$row['login']] = $row['htpass'];

	$fichier = @fopen($htpasswd, "w");
	if ($fichier) {
		ecrire_logins($fichier, $logins);
		fclose($fichier);
	} else {
		redirige_par_entete("../spip_test_dirs.php3");
	}

	$query = "SELECT login, htpass FROM spip_auteurs WHERE statut = '0minirezo'";
	$result = spip_query_db($query);

	$logins = array();
	while($row = spip_fetch_array($result)) $logins[$row['login']] = $row['htpass'];

	$fichier = fopen("$htpasswd-admin", "w");
	ecrire_logins($fichier, $logins);
	fclose($fichier);
}


function generer_htpass($pass) {
	global $htsalt, $flag_crypt;
	if ($flag_crypt) return crypt($pass, $htsalt);
	else return '';
}

//
// Verifier la presence des .htaccess
//
function verifier_htaccess($rep) {
	$htaccess = "$rep/" . _ACCESS_FILE_NAME;
	if ((!@file_exists($htaccess)) AND 
	    !defined('_ECRIRE_INSTALL') AND !defined('_TEST_DIRS')) {
		spip_log("demande de creation de $htaccess");
		if ($_SERVER['SERVER_ADMIN'] != 'www@nexenservices.com'){
			if (!$f = fopen($htaccess, "w"))
				echo "<b>" .
				  "ECHEC DE LA CREATION DE $htaccess" . # ne pas traduire
				  "</b>";
			else
			  {
				fputs($f, "deny from all\n");
				fclose($f);
			  }
		} else {
			echo "<font color=\"#FF0000\">IMPORTANT : </font>";
			echo "Votre h&eacute;bergeur est Nexen Services.<br />";
			echo "La protection du r&eacute;pertoire <i>$rep/</i> doit se faire
			par l'interm&eacute;diaire de ";
			echo "<a href=\"http://www.nexenservices.com/webmestres/htlocal.php\"
			target=\"_blank\">l'espace webmestres</a>.";
			echo "Veuillez cr&eacute;er manuellement la protection pour
			ce r&eacute;pertoire (un couple login/mot de passe est
			n&eacute;cessaire).<br />";
		}
	}
}

function gerer_htaccess() {
	$mode = lire_meta('creer_htaccess');
	$r = spip_query("SELECT extension FROM spip_types_documents");
	while ($e = spip_fetch_array($r)) {
		if (is_dir($dir = _DIR_DOC . $e['extension'])) {
			if ($mode == 'oui')
				verifier_htaccess($dir);
			else @unlink("$dir/" . _ACCESS_FILE_NAME);
		}
	}
	return $mode;
}

// En profiter pour verifier la securite de ecrire/data/
verifier_htaccess(_DIR_SESSIONS);

initialiser_sel();

?>
